function phantomObject = cystCharacteristics(phantomObjectVec, phantomObject, first_BS, limit)

load param.mat;

no = length(phantomObjectVec);

edge1 = [];
edge2 = [];

beam		= round(first_BS.beams);        % just to be sure...
sample		= round(first_BS.samples);
minBeam     = info.gridSize(2);                     minSample	= info.gridSize(1);
totMinB     = info.gridSize(2);						totMinS     = info.gridSize(1);
maxBeam     = 0;									maxSample	= 0;
totMaxB     = 0;									totMaxS     = 0;
meanMaxB	= 0;									meanMaxS	= 0;
meanMinB	= 0;									meanMinS	= 0;
meanValue	= 0;
cnt         = 0;
prev        = 0;
complete    = false;

while(~complete)
    
    switch (prev)					% forward = 0, upwards = 1, backwards = 2, downwards = 3
        case 0
            if( data(sample-1,beam) < limit && (sample-1) > 1 )
                sample	= sample-1;		% going upwards
                prev	= 1;
            elseif( data(sample,beam+1) < limit && (beam+1) < (info.gridSize(2)-1) )
                beam	= beam+1;		% going forward
                prev	= 0;
            elseif( data(sample+1,beam) < limit && (sample+1) < (info.gridSize(1)-1) )
                sample	= sample+1;		% going downwards
                prev	= 3;
            elseif( (beam-1) > 1 && data(sample,beam-1) < limit )
                beam	= beam-1;		% going backwards
                prev	= 2;
            else						% just one point
                complete = true;
            end 
        case 1
            if( (beam-1) > 1 && data(sample,beam-1) < limit )
                beam	= beam-1;		% going backwards
                prev	= 2;
            elseif( data(sample-1,beam) < limit && (sample-1) > 1 )
                sample	= sample-1;		% going upwards
                prev	= 1;
            elseif( data(sample,beam+1) < limit && (beam+1) < (info.gridSize(2)-1) )
                beam	= beam+1;		% going forward
                prev	= 0;
            elseif( data(sample+1,beam) < limit && (sample+1) < (info.gridSize(1)-1) )
                sample	= sample+1;		% going downwards
                prev	= 3;
            else
                complete = true;
            end
        case 2
            if( data(sample+1,beam) < limit && (sample+1) < (info.gridSize(1)-1) )
                sample	= sample+1;		% going downwards
                prev	= 3;
            elseif( (beam-1) > 1 && data(sample,beam-1) < limit )
                beam	= beam-1;		% going backwards
                prev	= 2;
            elseif( data(sample-1,beam) < limit && (sample-1) > 1 )
                sample	= sample-1;		% going upwards
                prev	= 1;
            elseif( data(sample,beam+1) < limit && (beam+1) < (info.gridSize(2)-1) )
                beam	= beam+1;		% going forward
                prev	= 0;
            else
                complete = true;	
            end
        case 3
            if( data(sample,beam+1) < limit && (beam+1) < (info.gridSize(2)-1) )
                beam	= beam+1;		% going forward
                prev	= 0;
            elseif( data(sample+1,beam) < limit && (sample+1) < (info.gridSize(1)-1) )
                sample	= sample+1;		% going downwards
                prev	= 3;
            elseif( (beam-1) > 1 && data(sample,beam-1) < limit )
                beam	= beam-1;		% going backwards
                prev	= 2;
            elseif( data(sample-1,beam) < limit && (sample-1) > 1 )
                sample	= sample-1;		% going upwards
                prev	= 1;
            else
                complete = true;
            end
    end

    if ( sample == round(first_BS.samples) && beam == round(first_BS.beams) )
        complete = true;
    else
        edge1 = [edge1 beam];
        edge2 = [edge2 sample];
    end
end

if (isempty(edge1))
    phantomObject.radRes = 0;
    phantomObject.latRes = 0;
    return;
end

% determine lateral and radial resolution
for i = 1:length(edge1)
    totMinB	= minValue(totMinB, edge1(i));
    totMaxB	= maxValue(totMaxB, edge1(i));
    totMinS	= minValue(totMinS, edge2(i));
    totMaxS	= maxValue(totMaxS, edge2(i));
end

for s = totMinS:totMaxS
    for i = 1:length(edge1)
        if (edge2(i) == s)
            minBeam = minValue(minBeam, edge1(i));	% finding extreme points for every sample
            maxBeam = maxValue(maxBeam, edge1(i));
        end
    end
    meanMaxB = meanMaxB + maxBeam;
    meanMinB = meanMinB + minBeam;
end

meanMaxB = round(meanMaxB/(totMaxS-totMinS+1));
meanMinB = round(meanMinB/(totMaxS-totMinS+1));
lengthPO = meanMaxB - meanMinB;
middleB	 = round(meanMinB + lengthPO/2);

for b = totMinB:totMaxB
    for i = 1:length(edge2)
        if (edge1(i) == b)
            minSample = minValue(minSample, edge2(i)); %finding extreme points for every beam
            maxSample = maxValue(maxSample, edge2(i));
        end
    end
    % finding mean intensity for cyst
    for theS = minSample:maxSample
        valueCenter = data(theS,b);
        meanValue   = meanValue + valueCenter;
        cnt         = cnt + 1;
    end
    meanMaxS = meanMaxS + maxSample;
    meanMinS = meanMinS + minSample;
end

meanMaxS = round(meanMaxS/(totMaxB-totMinB+1));
meanMinS = round(meanMinS/(totMaxB-totMinB+1));
depthPO	 = meanMaxS - meanMinS;
middleS	 = round(meanMinS + depthPO/2);

meanValue = meanValue/cnt;
phantomObject.meanInt = meanValue;

% lateral
[res1_PS.x res1_PS.y]   = fromBeamSpace(middleS, meanMinB, info);
[res2_PS.x res2_Ps.y]   = fromBeamSpace(middleS, meanMaxB, info);
phantomObject.latResmm  = (res2_PS.x - res1_PS.x)*1000;

% radial
[res1_PS.x res1_PS.y]   = fromBeamSpace(meanMinS, middleB, info);
[res2_PS.x res2_PS.y]   = fromBeamSpace(meanMaxS, middleB, info);
phantomObject.radResmm  = (res2_PS.y - res1_PS.y)*1000;

[xy.x xy.y] = fromBeamSpace(middleS, middleB, info);

phantomObject.beam      = middleB;
phantomObject.sample    = middleS;
phantomObject.posX      = xy.x;
phantomObject.posY      = xy.y;
phantomObject.radRes    = depthPO;
phantomObject.latRes    = lengthPO;
phantomObject.type      = 'CYST';


    %		CONTRAST RESOLUTION CALCULATIONS
    % ---------------------------------------------

minDiffTot  = 1000;
meanSpeckle = 0;
index		= -1;		
cntS		= 0;

% Searching for nearest point target at the same depth as the cyst, but in the middle of the x axis
[bs.samples bs.beams] = toBeamSpace(0,xy.y-0.05,info);        % xy.x = 0 -> the middle

for j = 1:no-1
    if (strcmp(phantomObjectVec(j).type,'POINT_TARGET'))
        diffB	= abs(phantomObjectVec(j).beam - round(bs.beams));
        diffS	= abs(phantomObjectVec(j).sample - round(bs.samples));
        diffTot = diffB + diffS;
        if (diffTot < minDiffTot)
            minDiffTot  = diffTot;
            index       = j;
        end
    end
end

% find speckle to the right of point target
[xy.x xy.y]             = fromBeamSpace(phantomObjectVec(index).sample, phantomObjectVec(index).beam, info);
[bs.samples, bs.beams]  = toBeamSpace(xy.x + 0.008, xy.y - 0.005, info);

for b = round(bs.beams):round(bs.beams) + 25
    for s = round(bs.samples + 0.5):round(bs.samples) + 75
        valueCenter = data(s,b);
        meanSpeckle = meanSpeckle + valueCenter;
        cntS        = cntS + 1;
    end
end

if (cntS == 0)
    meanSpeckle = 0;
else
    meanSpeckle = meanSpeckle/cntS;
end

meanValuePreComp    = hCompInverse(meanValue,info.preComp);
meanSpecklePreComp	= hCompInverse(meanSpeckle,info.preComp);
meanPTPreComp		= hCompInverse(phantomObjectVec(index).meanInt,info.preComp);

contrastRes1 = 20*log10(meanSpecklePreComp/meanValuePreComp);
contrastRes2 = 20*log10(meanPTPreComp/meanValuePreComp);

if (index ~= -1)
    phantomObject.contrastRes_pointTarget = -1;
else
    phantomObject.contrastRes_pointTarget = contrastRes2;
end

phantomObject.contrastRes_speckle = contrastRes1;

function minV = minValue(minVal, value)
	
if (minVal > value)
    minV = value;
else
    minV = minVal;
end

function maxV = maxValue(maxVal, value)
	
if (maxVal < value)
    maxV = value;
else
    maxV = maxVal;
end