function [x,y] = fromBeamSpace(s,b,info)

if (info.useGcMat)   
    % Must be used when having iq data
    x = info.x_scan(b,s);
    y = info.y_scan(b,s);
else
    startDepth  = div(2);
    endDepth    = div(3);
    theta_start = div(4);
    theta_end   = div(5);
    m_gridSize  = [div(6) div(7)];

    alpha       = (b/(m_gridSize(2)-1))*(theta_end-theta_start) - abs(theta_start);
    r           = (s-1)*(endDepth-startDepth)/(m_gridSize(1)-1);
    x           = r*tan(alpha)/sqrt(1+(tan(alpha).^2));
    y           = sqrt(r.^2 - x.^2);
end