function res = gainDistribution(phantomObjectVec)

load param.mat;

    %    GAIN DISTRIBUTION ALONG A VERTICAL LINE
    %				  CONSISTING SPECKLE
    % -----------------------------------------------

minDist		= 1;
startX		= phantomObjectVec(1).posX + 0.01;
res = struct();
res.gainDist1 = [];   % 1. value for speckle,
res.gainDist2 = [];   % 2. y coord.
res.gainDist3 = [];   % 3. value for point target 
res.gainDist4 = [];   % 4. y coord

TEMP = [];

% finding starting sample
for s = 1:info.gridSize(1)
    [upper_PS.x upper_PS.y] = fromBeamSpace(s,info.gridSize(2), info);
    diff = abs(upper_PS.x - startX);
    if (diff < minDist)
        minDist		= diff;
        start_PS	= upper_PS;
    end
end

[start_BS.samples start_BS.beams] = toBeamSpace(start_PS.x, start_PS.y, info);
b	= round(start_BS.beams);

% register vertical line with intensity values
for s = round(start_BS.samples):info.gridSize(1)

    % Testing if we should increase beam
    [test1_PS.x test1_PS.y] = fromBeamSpace(s,b,info);
    [test2_PS.x test2_PS.y] = fromBeamSpace(s,b-1,info);

    if ( abs(test1_PS.x - startX) > abs(test2_PS.x - startX) )	% do increase
        b = b - 1;
    end

    if (b > 1 )
        
        if ( ((b-2) > 0) && ((b+2) < info.gridSize(2)) ) 
            valuePrevPrevBeam	= data(s,b-2);
            valuePrevBeam		= data(s,b-1);
            valueCenter     	= data(s,b);
            valueNextBeam		= data(s,b+1);
            valueNextNextBeam	= data(s,b+2);
            value = (valuePrevPrevBeam + valuePrevBeam + valueCenter + valueNextBeam + valueNextNextBeam)/5;
        else
            value = data(s,b);
        end

        [tmp_PS.x tmp_PS.y] = fromBeamSpace(s,b,info);
        TEMP = [TEMP tmp_PS.x];
        res.gainDist1 = [res.gainDist1 round(value)];
        res.gainDist2 = [res.gainDist2 tmp_PS.y];
    end
end

% figure(97)
% % Display image
% pcolor(info.x_scan,info.y_scan,data');
% shading interp; colormap(gray(256));
% axis equal; axis ij;
% xlabel('Azimuth [mm]');ylabel('Depth [mm]');
% line(TEMP,res.gainDist2);
TEMP = [];


    %     GAIN DISTRIBUTION ALONG A LINE CONSISTING
    %				VERTICAL POINT TARGETS
    % --------------------------------------------------


% upper point target -> phantomObjectVector no. 2

% values before the first point target
for s=1:phantomObjectVec(2).sample
    b = phantomObjectVec(2).beam;
    if ( ((b-1) > 0) && ((b+1) < info.gridSize(2)) ) 
        valuePrevBeam		= data(s,b-1);
        valueCenter     	= data(s,b);
        valueNextBeam		= data(s,b+1);
        value = (valuePrevBeam + valueCenter + valueNextBeam)/3;
    else
        value = data(s,b);
    end

    [tmp_PS.x tmp_PS.y] = fromBeamSpace(round(s),round(b),info);
    TEMP = [TEMP tmp_PS.x];
    res.gainDist3 = [res.gainDist3 round(value)];
    res.gainDist4 = [res.gainDist4 tmp_PS.y];
end

% values between upper and the center point target
p		= 0;
b2		= phantomObjectVec(2).beam;
diffB	= phantomObjectVec(1).beam   - phantomObjectVec(2).beam;
diffS   = phantomObjectVec(1).sample - phantomObjectVec(2).sample;

if (diffB == 0)
    perPart = info.gridSize(1);
else
    perPart = round(diffS/abs(diffB+1));
end

for s2 = phantomObjectVec(2).sample:phantomObjectVec(1).sample	

    if ( p == perPart)
        if (diffB > 0)
            b2 = b2 + 1;
        else
            b2 = b2 - 1;
        end
        p = 0;
    end

    if (b2 < info.gridSize(2) )
        if ( ((b2-1) > 0) && ((b2+1) < info.gridSize(2)) ) 
            valuePrevBeam		= data(s2,b2-1);
            valueCenter     	= data(s2,b2);
            valueNextBeam		= data(s2,b2+1);
            value = (valuePrevBeam + valueCenter + valueNextBeam)/3;
        else
            value = data(s2,b2);
        end

        [tmp_PS.x tmp_PS.y] = fromBeamSpace(round(s2),round(b2), info);
        TEMP = [TEMP tmp_PS.x];
        res.gainDist3 = [res.gainDist3 round(value)];
        res.gainDist4 = [res.gainDist4 tmp_PS.y];
    end
    p = p + 1;
end

% values after the center point target
for s = phantomObjectVec(1).sample:info.gridSize(1)
     b = phantomObjectVec(1).beam;  
    if ( ((b-1) > 0) && ((b+1) < info.gridSize(2)) ) 
        valuePrevBeam		= data(s,b-1);
        valueCenter     	= data(s,b);
        valueNextBeam		= data(s,b+1);
        value = (valuePrevBeam + valueCenter + valueNextBeam)/3;
    else
        value = data(s,b);
    end

    [tmp_PS.x tmp_PS.y] = fromBeamSpace(round(s),round(b),info);
    TEMP = [TEMP tmp_PS.x];
    res.gainDist3 = [res.gainDist3 round(value)];
    res.gainDist4 = [res.gainDist4 tmp_PS.y];
end

% figure(100)
% % Display image
% pcolor(info.x_scan,info.y_scan,data');
% shading interp; colormap(gray(256));
% axis equal; axis ij;
% xlabel('Azimuth [mm]');ylabel('Depth [mm]');
% line(TEMP,res.gainDist4);