%   MENU FOR IMAGE ANALYSIS SYSTEM
% ---------------------------------------
% 06.06.09 Cecilie ins Simpson

% Run total analysis:           image analysis, spatial variance (and
%                               ProbeContact if recorded image is chosen)
% Run only spatial variance:    only spatialVariance
% If recorded image is chosen:
% Run only ProbeContact:        only ProbeContact
clear;

K = menu('What kind of image do you want to analyse?','Recorded image','Simulated image');

if K == 1
    L = menu('Choose what you want to do','Run total analysis (requires an image with more than 45 degrees sector width)','Run only spatial variance','Run only ProbeContact');
    if L == 1 || L == 2
        prompt={'MLA','Calculations with speckle (Yes = 1, No = 0)','Calculations with various point targets (Yes = 1, No = 0)',...
            'Make movie (Yes = 1, No = 0)', 'Calculations with IQ-data (Yes = 1, No = 0)'};
        name='Parameters in spatialVariance';
        numlines = 1;
        defaultanswer={num2str(1),num2str(0),num2str(0),num2str(0),num2str(0)};
        options.Resize='on';
        options.WindowStyle='normal';
        answer = inputdlg(prompt,name,numlines,defaultanswer,options);
        if (isempty(answer))
            disp('No analysis was done.')
            return;
        else
            if L == 1
                imageAnalyzer;
            end
            spatialVariance(str2double(char(answer(1))),str2double(char(answer(2))),str2double(char(answer(3)))...
               ,str2double(char(answer(4))),str2double(char(answer(5))));
        end        
    else
        prompt={'Enter path for ProbeContact files:                                       .'};
        name='Path for ProbeContact files';
        numlines = 1;
        defaultanswer={'C:\Documents and Settings\Cecilie Simpson\My Documents\Skole\2009\Master\Prog\ProbeContactMatlab\'};
        options.Resize='on';
        options.WindowStyle='normal';
        answer = inputdlg(prompt,name,numlines,defaultanswer,options);
        if (isempty(answer))
            disp('No analysis was done.')
            return;
        else
            addpath(char(answer));
            probeContact;
        end
    end
elseif K == 2
    L = menu('Choose what you want to do','Run total analysis (requires an image with more than 45 degrees sector width)','Run only spatial variance');
    prompt={'Path for simulated files','MLA','Calculations with speckle (Yes = 1, No = 0)','Calculations with various point targets (Yes = 1, No = 0)',...
        'Make movie (Yes = 1, No = 0)', 'Calculations with IQ-data (Yes = 1, No = 0)'};
    name='Parameters in spatialVariance';
    numlines = 1;
    if L == 1
        defaultanswer={'W:\Field\Phantoms\75',num2str(1),num2str(0),num2str(0),num2str(0),num2str(0)};
    else
        defaultanswer={'W:\Field\Phantoms\A',num2str(1),num2str(0),num2str(0),num2str(0),num2str(0)};
    end
    options.Resize='on';
    options.WindowStyle='normal';
    answer = inputdlg(prompt,name,numlines,defaultanswer,options);
    if (isempty(answer))
        disp('No analysis was done.')
        return;
    else
        if L == 1
            imageAnalyzerForField(char(answer(1)));
        end
        spatialVarianceForField(char(answer(1)),str2double(char(answer(2))),str2double(char(answer(3))),str2double(char(answer(4)))...
           ,str2double(char(answer(5))),str2double(char(answer(6))));
    end
else
   disp('No analysis was done.') 
end
