function over = overTheThreshold(theBeam, theSample)

load param.mat;

candidates1 = [];		% 1. beam
candidates2 = [];       % 2. sample

% Threshold for intensity level of possible point targets
threshold = 50;

% Copy data
copyData = data;

% Mean of the total image, divided into 9 parts
mean    = [];
levels	= 9;
parts	= floor(info.gridSize(1)/levels);
temp	= 0;
for i = 0:(levels-1)
    for sample=1+i*parts:parts+i*parts
        for beam=1:info.gridSize(2);
            temp = temp + data(sample,beam);
        end
    end
    mean = [mean temp];
    temp = 0;
end

for j= 1:length(mean)
    mean(j) = mean(j)/(info.gridSize(2)*parts-2);
end

% Finding possible candidates for point targets
for i = 0:(levels-1)
    for sample=1+i*parts:parts+i*parts
        for beam=1:info.gridSize(2)
            copyData(sample, beam)	= abs(data(sample,beam)-mean(i+1));
        end
    end
end

for beam=2:info.gridSize(2)
    for sample=1:info.gridSize(1)
        valueCenter = copyData(sample,beam);
        % Possible candidates over a given threshold
        if ( (valueCenter) > threshold )
            candidates1 = [candidates1 beam];
            candidates2 = [candidates2 sample];		
        end
    end
end

over = false;

for i = 1:length(candidates2)
    if ( candidates1(i) == theBeam && candidates2(i) == theSample )
        over = true;
    end
end
