function [s,b] = toBeamSpace(x,y,info)


if (info.useGcMat)    
    % Must be used when having iq data
    [min_diffX, array_posX] = min(abs(info.x_scan - x),[],1);   % find all points along y that are close to x           
    x1 = zeros(1,length(array_posX));
    y1 = zeros(1,length(array_posX));
    for i = 1:length(array_posX)
        x1(i) = info.x_scan(array_posX(i),i);
        y1(i) = info.y_scan(array_posX(i),i);
    end
    [i,j] = (min(abs(x1-x) + abs(y1-y)));
    s = j;
    b = array_posX(j);
else
    startDepth  = div(2);
    endDepth    = div(3);
    theta_start = div(4);
    theta_end   = div(5);
    m_gridSize  = [div(6) div(7)];
    
    r           = sqrt(x.^2+y.^2);
    alpha       = atan2(x,y);
    alpha       = alpha + abs(theta_start); 
    s           = (r*(m_gridSize(1)-1)/(endDepth-startDepth)) + 1;
    b           = (alpha*(m_gridSize(2)-1)/(theta_end-theta_start));
end

