
function info = getDataInfo(h,type)

info = struct();

info.c = 1540;

if(strcmp(lower(type),'iq')) % IQ data info.
    info.PRF = gcudtparam(h,'IQ','PRF');
    info.f0 = gcudtparam(h,'IQ','Frequency');
    info.fDem = gcudtparam(h,'IQ','FreqDemod');
    gridSize = gcudtparam(h,'IQ','GridSize');
    info.ranges = gridSize(1);
    info.beams = gridSize(2);
    info.packetsize = double(gcudtparam(h,'IQ','PacketSize'));
    info.frameRate = gcudtparam(h,'IQ','FrameRate');
    info.width = gcudtparam(h,'IQ','Width');
    info.depthStart = gcudtparam(h,'IQ','DepthStart');
    info.depthEnd = gcudtparam(h,'IQ','DepthEnd');    
    info.focusPos = gcudtparam(h,'IQ','Focus',-1,[],0,'UDT');
    info.txAperture = gcudtparam(h,'IQ','TxAperture',-1,[],0,'UDT');
    info.noFrames = gcudtparam(h,'IQ','NoOfFrames');
    
    % Derived parameters
    info.depthInc = (info.depthEnd - info.depthStart) / info.ranges;
    info.latInc = info.width / info.beams;
    info.frs = info.c/2/info.depthInc;
    info.vNyquist = info.c*info.PRF / (4*info.fDem);
end